web/mrr/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.views.generic import RedirectView

import mrr_calculations.views as mrr_calc_views

urlpatterns = [
    url('^', include('django.contrib.auth.urls')),
    url(r'^(?i)$', RedirectView.as_view(url='/login')),
    # Add New CSV
    url(r'^upload_csv/?$', mrr_calc_views.UploadCsvView.as_view()),
    url(r'^update_csv/(?P<tr_id>\d+)/?$', mrr_calc_views.UpdateCsvView.as_view()),
    url(r'^process_data/?$', mrr_calc_views.ProcessView.as_view()),
    # Bar Graphs & Scatter Graphs
    url(r'^bar_analytics/?$', mrr_calc_views.AnalyticsView.as_view()),
    # Accounts
    url(r'^accounts/?$', mrr_calc_views.AccountsView.as_view()),
    url(r'^get_account_mrr/(?P<account_id>\d+)/?$', mrr_calc_views.SingleAccountMrrView.as_view()),
    # Internal Admin Tooling
    url(r'^(?i)admin/?', admin.site.urls),
]

web/mrr_calculations/models.py
from django.db import models

class CsvUpload(models.Model):
    date_uploaded = models.DateTimeField(auto_now_add=True)
    title = models.CharField(max_length=100)

    def __unicode__(self):
        return u'%s - %s' % (self.title, self.date_uploaded)

# TODO - make internal name the primary key for quicker insertion?
class Customer(models.Model):
    internal_name = models.CharField(max_length=150, unique=True)
    name = models.CharField(max_length=100, null=True)
    primary_lip = models.ForeignKey('self',null=True)
    category = models.CharField(max_length=50,null=True)

    def __unicode__(self):
        return u'%s' % (self.internal_name)

class InvoiceItem(models.Model):
    invoice_number = models.CharField(max_length=50)
    invoice_date = models.DateField()
    transaction_type = models.CharField(max_length=50)
    product_type = models.CharField(max_length=100)
    quantity = models.DecimalField(null=True,max_digits=12, decimal_places=5)
    rate = models.DecimalField(null=True, max_digits=12, decimal_places=5)
    amount = models.DecimalField(null=True, max_digits=12, decimal_places=5)
    memo = models.TextField(null=True)
    customer = models.ForeignKey(Customer)
    orig_csv = models.ForeignKey(CsvUpload)
    is_processed = models.BooleanField(default=False)
    start_date = models.DateField(null=True)
    end_date = models.DateField(null=True)
    product_class = models.CharField(max_length=50)
    revenue_type = models.CharField(max_length=50)

    def __unicode__(self):
        return u'%s - %s %s' % (self.customer,self.revenue_type,self.amount)

class ClientMrr(models.Model):
    mrr = models.DecimalField(max_digits=12,decimal_places=5)
    customer = models.ForeignKey(Customer)
    month = models.DateField()
    classification = models.CharField(max_length=25)
    classification_value = models.DecimalField(null=True, max_digits=12, decimal_places=5)

    def __unicode__(self):
        return u'%s | %s | %s | %s' % (self.customer, self.month, self.mrr, self.classification)

web/mrr_calculations/forms.py
from django import forms

# TODO - validate that this is the header of the file
# Date,Transaction Type,Num,Client,Product/Service,Memo/Description,Qty, Rate , Amount ,Type of Revenue,Type of Customer,Start Date,End Date,Product Class
class CsvUploadForm(forms.Form):
    title = forms.CharField(max_length=100)
    file = forms.FileField()

web/mrr/views.py
from django.views.generic import TemplateView
from django.http import HttpResponse

class UploadCsvView(TemplateView):
    template_name = "upload_csv.html"

    def get(self, request):
        return render_to_response(self.template_name, {})

    

web/mrr_calculations/views.py
import datetime
import json

from dateutil import relativedelta

from django.views.generic import TemplateView
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render
from django.core import serializers
from django.core.serializers.json import DjangoJSONEncoder

from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator

from mrr_calculations.forms import CsvUploadForm
from mrr_calculations.mrr_processing import process_csv, query_mrr, query_bookings, process_new_mrr
from mrr_calculations.models import CsvUpload, InvoiceItem, ClientMrr, Customer

@method_decorator(login_required, name='dispatch')
class UploadCsvView(TemplateView):
    template_name = "mrr_calculations/upload_csv.html"

    def get(self, request):
        # IF THERE IS UNCLASSIFIED MRR
        # DISPLAY THAT INSTEAD OF THE UPLOAD FORM
        form = CsvUploadForm()
        invoice_items = InvoiceItem.objects.filter(is_processed=False)
        return render(request, self.template_name, {'form':form, 'invoice_items':invoice_items})

    def post(self, request):
        form = CsvUploadForm(request.POST, request.FILES)
        if form.is_valid():
            try:
                invoice_rows = process_csv(request.FILES['file'], request.FILES['file'].name)
                return render(request, self.template_name, {'form':CsvUploadForm(), 'invoice_items':invoice_rows})
            except ValueError as e:
                form.add_error(None, repr(e))


        return render(request, self.template_name, {'form':form})


@method_decorator(login_required, name='dispatch')
class UpdateCsvView(TemplateView):

    def post(self, request, tr_id):
        invoice_items = InvoiceItem.objects.filter(id=int(tr_id))
        updated_invoice_item = invoice_items[0]
        updated_invoice_item.start_date = request.POST.get("start_date")
        updated_invoice_item.end_date = request.POST.get("end_date")
        updated_invoice_item.product_class = request.POST.get("product_class")
        updated_invoice_item.revenue_type = request.POST.get("revenue_type")
        updated_invoice_item.save()

        data = serializers.serialize('json', invoice_items)
        return HttpResponse(data, content_type='application/json')

@method_decorator(login_required, name='dispatch')
class ProcessView(TemplateView):

    def get(self, request):
        process_new_mrr()
        return HttpResponseRedirect('/upload_csv/')

@method_decorator(login_required, name='dispatch')
class AnalyticsView(TemplateView):
    template_name = "mrr_calculations/analytics.html"

    def get(self, request):
        kwargs = {}
        start_date, end_date = None, None

        if 'start_date' in request.GET:
            start_date = request.GET['start_date']
        if 'end_date' in request.GET:
            end_date = request.GET['end_date']

        # Query for the bookings data and stick it in our list
        mrr_list = query_bookings(start_date,end_date,None, **kwargs)

        if 'format' in request.GET and request.GET['format'] == 'json':
            return HttpResponse(json.dumps(mrr_list, cls=DjangoJSONEncoder))
        else:
            return render(request, self.template_name, {'mrr_types':mrr_list})


@method_decorator(login_required, name='dispatch')
class ScatterView(TemplateView):
    template_name = "mrr_calculations/scatter.html"

    def get(self, request):
        kwargs = {}
        start_date, end_date = None, None

        if 'client' in request.GET:
            kwargs['customer_id'] = int(request.GET['client'])
        if 'start_date' in request.GET:
            start_date = request.GET['start_date']
        if 'end_date' in request.GET:
            end_date = request.GET['end_date']

        # Query for the bookings data and stick it in our list
        mrr_list = query_bookings(start_date,end_date,None, **kwargs)

        if 'format' in request.GET and request.GET['format'] == 'json':
            return HttpResponse(json.dumps(mrr_list, cls=DjangoJSONEncoder))
        else:
            return render(request, self.template_name, {'mrr_types':mrr_list})


@method_decorator(login_required, name='dispatch')
class AccountsView(TemplateView):
    template_name = "mrr_calculations/accounts.html"

    def get(self, request):
        customers = Customer.objects.all()

        return render(request, self.template_name, {'customers':customers})


class SingleAccountMrrView(TemplateView):

    def get(self, request, account_id):

        return HttpResponse(json.dumps({'success':True}), content_type='application/json')

web/templates/base.html
{% load static from staticfiles %}

<!DOCTYPE html>
<!--
Leaders in high-performance referral management! Come work for us!
https://www.treatspace.com/company/careers
-->

{% spaceless %}
<html lang="en">
    <head>
        <title>{% block title %}Treatspace MRR Access{% endblock %}</title>

        <meta charset="utf-8">
        <meta name="apple-mobile-web-app-capable" content="yes" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
        <meta name="apple-mobile-web-app-status-bar-style" content="black" />
        <meta http-equiv="X-UA-Compatible" content="chrome=1">
        <meta name="robots" content="noindex" />

        
        <link rel="shortcut icon" href="">
        <link rel="stylesheet" href="{% static "/bootstrap/css/bootstrap.min.css" %}">
        <link rel="stylesheet" href="{% static "/dist/css/AdminLTE.min.css" %}">
	    <link rel="stylesheet" href="{% static "/dist/css/skins/_all-skins.min.css" %}">
	    <link rel="stylesheet" href="{% static "/dist/css/flat-ui-pro.css" %}">
        <link rel="stylesheet" href="{% static "/custom/css/style.css" %}">
        <!-- Script -->
    </head>

    <body class="skin-blue fixed" data-spy="scroll" data-target="#scrollspy">
    	
		{% block content %}
  		{% endblock %}

        <!-- jQuery 2.2.3 -->
	    <script src="{% static "/plugins/jQuery/jquery-2.2.3.min.js" %}"></script>
	    <!-- Bootstrap 3.3.6 -->
	    <script src="{% static "/bootstrap/js/bootstrap.min.js" %}"></script>
	    <!-- FastClick -->
	    <script src="{% static "/plugins/fastclick/fastclick.min.js" %}"></script>
	    <!-- AdminLTE App -->
	    <script src="{% static "/dist/js/app.min.js" %}"></script>
	    <!-- SlimScroll 1.3.0 -->
	    <script src="{% static "/plugins/slimScroll/jquery.slimscroll.min.js" %}"></script>

	    {% block js %}
	    {% endblock %}
    </body>
</html>
{% endspaceless %}

web/templates/internal-base.html
{% extends "base.html" %}
{% load static from staticfiles %}

{% block content %}
<header class="main-header">
	<a id="site-identifier" href="" class="logo" data-token="{{ csrf_token }}">
		<!-- Treatspace MRR -->
		<img src="{% static "/custom/icons/treatspace-logo-white.svg" %}" alt="treatspace-logo" class="logo" width="200" height="52">
	</a>
	<nav class="navbar navbar-static-top" role="navigation">
		<div class="navbar-custom-menu">
			<ul class="nav navbar-nav">
				<li class="dropdown user user-menu">
					<a href="#" class="dropdown-toggle" data-toggle="dropdown">
						<img src="{% static "/custom/icons/dude.svg" %}" class="user-image" alt="User Image">
						<span class="hidden-xs">{{ request.user.username }}</span>
					</a>
					<ul class="dropdown-menu">
						<li class="user-header">
							<img src="{% static "/custom/icons/dude.svg" %}" class="img-circle" alt="User Image">
							<p>
							{% if request.user.first_name and requet.user.last_name %}{{ reguest.user.first_name }} {{request.user.last_name }}{% else %}{{ request.user.username }}{% endif %}
							<small>Last login was {{request.user.last_login}}</small>
							</p>
						</li>
						<li class="user-footer">
							<div class="pull-right">
								<a href="/logout/?next=/login" class="btn btn-default btn-flat">Sign out</a>
							</div>
						</li>
					</ul>
				</li>
			</ul>
		</div>
	</nav>
</header>
<div class="main-sidebar">
	<div class="sidebar">
		<ul class="sidebar-menu">
			<li class="header">MRR</li>
			<li {% block upload_csv_sidetab_active %}{% endblock %}><a href="/upload_csv"><span>Add New CSV</span></a></li>
			<li {% block bar_sidetab_active %}{% endblock %}><a href="/bar_analytics"><span>Bar Graphs</span></a></li>
			<li {% block scatter_sidetab_active %}{% endblock %}><a href="/scatter_analytics"><span>Scatter Graph</span></a></li>
			<li {% block accounts_sidetab_active %}{% endblock %}><a href="/accounts"><span>Accounts</span></a></li>
		</ul>
	</div>
</div>
<div class="content-wrapper">
	{% block content_body %}
	{% endblock %}
</div>
{% endblock %}

web/templates/mrr_calculations/accounts.html
{% extends "internal-base.html" %}
{% load static from staticfiles %}

{% block js %}
<script src="{% static "/custom/js/general.js" %}"></script>
<script src="{% static "/custom/js/accounts.js" %}"></script>
{% endblock %}

{% block accounts_sidetab_active %}class="active"{% endblock %}

{% block content_body %}
<div class="content-header"></div>
<div class="content body">
	{% for customer in customers %}
	<div class="panel panel-success bottom-margin-20">
		<div class="panel-heading cursor-pointer" data-id="{{ customer.id }}">
			<div class="row">
				<div class="col-xs-10">{{ customer }}</div>
				<div class="col-xs-2 text-right"><span class="caret"></span></div>
			</div>
		</div>
		<div class="panel-body hidden">
			<div class="table-responsive">
				<table class="table">
					<thead>
						<tr>
							<th>
								Bookings
							</th>
							<th>
								Churn
							</th>
							<th>
								Contraction
							</th>
							<th>
								Expansion
							</th>
							<th>
								Month
							</th>
							<th>
								New MRR
							</th>
							<th>
								Total
							</th>
						</tr>
					</thead>
					<tbody>
						<tr class="hidden tr-clone">
							<td data-type="bookings"></td>
							<td data-type="churn_mrr"></td>
							<td data-type="contraction_mrr"></td>
							<td data-type="expansion_mrr"></td>
							<td data-type="month"></td>
							<td data-type="new_mrr"></td>
							<td data-type="total"></td>
						</tr>
					</tbody>
				</table>
			</div>
			<!-- New Account: <span data-type="new-account">No</span><br> -->
		</div>
	</div>
	{% endfor %}
</div>
{% endblock %}

web/templates/mrr_calculations/analytics.html
{% extends "internal-base.html" %}
{% load static from staticfiles %}

{% block js %}
<script src="{% static "/custom/js/general.js" %}"></script>
<script src="{% static "/dist/js/Chart.bundle.min.js" %}"></script>
<script src="{% static "/custom/js/analytics.js" %}"></script>
{% endblock %}

{% block bar_sidetab_active %}class="active"{% endblock %}

{% block content_body %}
<div class="content-header"></div>
<div id="graph-data">
	<div id="mrr-breakdown">
	{% for mrr_entry in mrr_types %}
		{% if mrr_entry.total %}
			<p data-x-label="{{mrr_entry.month|date:'M Y'}}" data-bookings="{{mrr_entry.bookings.normalize}}" data-type="data-row" data-total="{{mrr_entry.total.normalize}}" data-contraction="{{mrr_entry.contraction_mrr.normalize}}" data-expansion="{{mrr_entry.expansion_mrr.normalize}}" data-churn="{{mrr_entry.churn_mrr.normalize}}" data-new="{{mrr_entry.new_mrr.normalize}}"></p>
		{% endif %}
	{% endfor %}
	</div>
</div>
<div class="content body">
	<canvas id="sample-chart-1" class="mrr-chart"></canvas>
	<hr>
	<div class="table-responsive">
		<table id="sample-grid-1" class="table"></table>
	</div>
	<br>
	<hr>
	<canvas id="sample-chart-2" class="mrr-chart"></canvas>
	<hr>
	<div class="table-responsive">
		<table id="sample-grid-2" class="table"></table>
	</div>
	<br>
	<hr>
	<canvas id="sample-chart-3" class="mrr-chart"></canvas>
	<hr>
	<div class="table-responsive">
		<table id="sample-grid-3" class="table"></table>
	</div>
	<br>
	<hr>
</div>
{% endblock %}

web/templates/mrr_calculations/scatter.html
{% extends "internal-base.html" %}
{% load static from staticfiles %}

{% block js %}
<script src="{% static "/custom/js/general.js" %}"></script>
<script src="{% static "/dist/js/Chart.bundle.min.js" %}"></script>
<script src="{% static "/custom/js/scatter.js" %}"></script>
{% endblock %}

{% block scatter_sidetab_active %}class="active"{% endblock %}

{% block content_body %}
<div class="content-header"></div>
<div id="graph-data">
	<div id="mrr-breakdown">
		<p data-x-label="-20" data-new="13"></p>
		<p data-x-label="-18" data-new="3"></p>
		<p data-x-label="-16" data-new="-32"></p>
		<p data-x-label="-14" data-new="1"></p>
		<p data-x-label="-12" data-new="3"></p>
		<p data-x-label="-10" data-new="8"></p>
		<p data-x-label="-8" data-new="5"></p>
		<p data-x-label="-6" data-new="0"></p>
		<p data-x-label="-4" data-new="19"></p>
		<p data-x-label="-2" data-new="10"></p>
		<p data-x-label="0" data-new="-14"></p>
		<p data-x-label="2" data-new="-26"></p>
		<p data-x-label="4" data-new="-23"></p>
		<p data-x-label="6" data-new="-5"></p>
		<p data-x-label="8" data-new="12"></p>
		<p data-x-label="10" data-new="9"></p>
		<p data-x-label="12" data-new="-9"></p>
		<p data-x-label="14" data-new="12"></p>
		<p data-x-label="16" data-new="1"></p>
		<p data-x-label="18" data-new="-2"></p>
		<p data-x-label="20" data-new="-4"></p>
	</div>
</div>
<div class="content body">
	<canvas id="sample-chart-4" class="mrr-chart"></canvas>
	<hr>
</div>
{% endblock %}

web/templates/mrr_calculations/upload_csv.html
{% extends "internal-base.html" %}
{% load static from staticfiles %}

{% block js %}
<script src="{% static "/custom/js/general.js" %}"></script>
<script src="{% static "/custom/js/edit.js" %}"></script>
{% endblock %}

{% block upload_csv_sidetab_active %}class="active"{% endblock %}

{% block content_body %}
<div class="content-header"></div>
<div class="content body">
	<form method="post" action="/upload_csv/" enctype="multipart/form-data">
	    {% csrf_token %}
			{{ form.non_field_errors }}
	    <div class="row">
	    	<div class="col-xs-6">
			    <div class="form-group">
				    <label>{{ form.title.label_tag }}</label>
					<input id="id_title" maxlength="50" name="title" type="text" required=""  class="form-control">
				</div>
			</div>
			<div class="col-xs-6">
				<div class="form-group">
				    <label>{{ form.file.label_tag }}</label>
					<input id="id_file" name="file" type="file" required="" class="form-control">
				</div>
			</div>
		</div>

	    <input class="btn btn-primary bottom-margin-20" type="submit" value="Submit" />
	</form>

	{% if invoice_items %}
	<hr>
	<h5>Unprocessed New Data</h5>
	<div class="table-responsive">
		<table class="table table-bordered">
			<thead>
				<tr>
					<th>Action</th>

					<th>Start Date</th>
					<th>End Date</th>
					<th>Product Class</th>
					<th>Revenue Type</th>

					<th>Invoice #</th>
					<th>Invoice Date</th>

					<th>Transaction</th>
					<th>Product Type</th>

					<th>Memo</th>
					<th>Customer</th>
					<th>Amount</th>
					<th>Rate</th>
					<th>Quantity</th>
				</tr>
			</thead>
			<tbody>
			{% for item in invoice_items %}
			<tr data-id="{{item.id}}">
				<td>
					<i class="btn-link cursor-pointer glyphicon glyphicon-pencil"></i>
					<i class="btn-link cursor-pointer glyphicon glyphicon-floppy-disk hidden"></i>
				</td>

				<td data-type="start_date" class="editable">
					<span class="td-label">{{item.start_date|date:"m/d/Y"}}</span>
					<input data-type="start_date" data-required type="date" class="td-input hidden" value="{{item.start_date|date:"Y-m-d"}}" placeholder="mm/dd/yyyy" />
				</td>
				<td data-type="end_date" class="editable">
					<span class="td-label">{{item.end_date|date:"m/d/Y"}}</span>
					<input data-type="end_date" data-required type="date" class="td-input hidden" value="{{item.end_date|date:"Y-m-d"}}" placeholder="mm/dd/yyyy" />
				</td>
				<td data-type="product_class" class="editable">
					<span class="td-label">{{item.product_class}}</span>
					<input data-type="product_class" class="td-input hidden" value="{{item.product_class}}" placeholder="Product Class" />
				</td>
				<td data-type="revenue_type" class="editable">
					<span class="td-label">{{item.revenue_type}}</span>
					<input data-type="revenue_type" class="td-input hidden" value="{{item.revenue_type}}" placeholder="Revenue Type" />
				</td>

				<td data-type="invoice_number">{{item.invoice_number}}</td>
				<td data-type="invoice_date">{{item.invoice_date}}</td>

				<td data-type="transaction_type">{{item.transaction_type}}</td>
				<td data-type="product_type">{{item.product_type}}</td>

				<td data-type="memo">{{item.memo}}</td>
				<td data-type="customer">{{item.customer.name}}</td>
				<td data-type="amount">{{item.amount.normalize}}</td>
				<td data-type="rate">{{item.rate.normalize}}</td>
				<td data-type="quantity">{{item.quantity.normalize}}</td>
			</tr>
			{% endfor %}
			</tbody>
		</table>
	</div>
	<hr>
	<button id="process-data" class="btn btn-primary">Process New Data</button> <!-- href="/process_data/"  -->
	{% endif %}

</div>
{% endblock %}